      subroutine corr(FFTA1, FFTA2, hklx, hkly, lann, hann, value)
       
C     compute the correaltion coefficiency of two 2D DFT in the range of
C     radius from lann to hann, return value

      IMPLICIT NONE
      integer hklx, hkly
      real    FFTA1(0:hklx,-hkly:hkly)
      real    FFTA2(0:hklx,-hkly:hkly)
      real    lann, hann
      real    value
      
C     local variable
      double precision a1sum, a2sum, a1sqsum, a2sqsum, a1a2sum
      integer icount, x, y
      real    radius, lsq, hsq, xsq
      
      a1sum = 0.0
      a2sum = 0.0
      a1sqsum = 0.0
      a2sqsum = 0.0
      a1a2sum = 0.0
      icount = 0
      lsq = lann**2
      hsq = hann**2
      value = 0.
      
      if (lann.GE.hann) return
      do x = 0, hklx
         xsq = x**2
         do y = -hkly, hkly
            radius = xsq + y**2
            if (radius.LE.hsq .and. radius.ge.lsq) then 
C     a1sum   = a1sum + log(FFTA1(x,y)+1)
C     a2sum   = a2sum + log(FFTA2(x,y)+1)
C     a1sqsum = a1sqsum + (log(FFTA1(x,y)+1))**2
C     a2sqsum = a2sqsum + (log(FFTA2(x,y)+1))**2
C     a1a2sum = a1a2sum + (log(FFTA1(x,y)+1))*(log(FFTA2(x,y)+1))
               a1sum   = a1sum + FFTA1(x,y)
               a2sum   = a2sum + FFTA2(x,y)
               a1sqsum = a1sqsum + FFTA1(x,y)**2
               a2sqsum = a2sqsum + FFTA2(x,y)**2
               a1a2sum = a1a2sum + FFTA1(x,y)*FFTA2(x,y)
               icount = icount + 1
            endif
         enddo
      enddo
      if ( icount .GT. 0) then
         value = abs(a1a2sum - a1sum*a2sum / icount )
     +        / sqrt( abs( a1sqsum - a1sum**2 /icount))
     +        / sqrt( abs( a2sqsum - a2sum**2 /icount))
      endif
      
      return
      end subroutine corr
      
