      subroutine exch_intp(hkl_max, intpl, tmppl)
      
C     Sum contributions to array intpl from across all processes and
C     distribute results to all processes
C
C     Author, Yongchang Ji 1/1002
C     Modified, Bob Sinkovits 11/08/2006
      
      implicit none
      
      include 'mpif.h'
      include '../include/allprogs.inc'
      
      integer, intent(in) :: hkl_max
      
#ifdef SPREC
      real, intent(in) :: intpl(3, -hkl_max:hkl_max, -hkl_max:hkl_max, 
     +     0:hkl_max )
      real, intent(out) :: tmppl(3, -hkl_max:hkl_max, -hkl_max:hkl_max,
     +     frst_lst_iq(1,iam):frst_lst_iq(2,iam))
#else
      double precision, intent(in) :: intpl(3, -hkl_max:hkl_max, 
     +     -hkl_max:hkl_max, 0:hkl_max)
      double precision, intent(out) :: tmppl(3, -hkl_max:hkl_max, 
     +     -hkl_max:hkl_max, frst_lst_iq(1,iam):frst_lst_iq(2,iam))
#endif
      
      integer  node, count_array(0:num_nodes-1)
      
      do node = 0, num_nodes-1
         count_array(node) = (2*hkl_max + 1)**2 * 3 *
     +        (frst_lst_iq(2,node) - frst_lst_iq(1,node) + 1)
      enddo
      
#ifdef SPREC
      call mpi_reduce_scatter(intpl, tmppl, count_array, 
     +     MPI_REAL, MPI_SUM, MPI_COMM_WORLD, mpi_err)
#else
      call mpi_reduce_scatter(intpl, tmppl, count_array, 
     +     MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_WORLD, mpi_err)
#endif
      
      return
      end subroutine exch_intp
